package cn.iocoder.yudao.module.mes.service.itemrequisition;

import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;

import cn.iocoder.yudao.framework.test.core.ut.BaseDbUnitTest;

import cn.iocoder.yudao.module.mes.controller.admin.itemrequisition.vo.*;
import cn.iocoder.yudao.module.mes.dal.dataobject.itemrequisition.ItemRequisitionDO;
import cn.iocoder.yudao.module.mes.dal.mysql.itemrequisition.ItemRequisitionMapper;
import cn.iocoder.yudao.framework.common.pojo.PageResult;

import org.springframework.context.annotation.Import;

import javax.annotation.Resource;
import java.util.*;
import java.time.LocalDateTime;

import static cn.hutool.core.util.RandomUtil.*;
import static cn.iocoder.yudao.module.mes.enums.ErrorCodeConstants.*;
import static cn.iocoder.yudao.framework.test.core.util.AssertUtils.*;
import static cn.iocoder.yudao.framework.test.core.util.RandomUtils.*;
import static cn.iocoder.yudao.framework.common.util.date.LocalDateTimeUtils.*;
import static cn.iocoder.yudao.framework.common.util.object.ObjectUtils.*;
import static cn.iocoder.yudao.framework.common.util.date.DateUtils.*;
import static org.junit.jupiter.api.Assertions.*;
import static org.mockito.Mockito.*;

/**
 * {@link ItemRequisitionServiceImpl} 的单元测试类
 *
 * @author 内蒙必硕
 */
@Import(ItemRequisitionServiceImpl.class)
public class ItemRequisitionServiceImplTest extends BaseDbUnitTest {

    @Resource
    private ItemRequisitionServiceImpl itemRequisitionService;

    @Resource
    private ItemRequisitionMapper itemRequisitionMapper;

    @Test
    public void testCreateItemRequisition_success() {
        // 准备参数
        ItemRequisitionSaveReqVO createReqVO = randomPojo(ItemRequisitionSaveReqVO.class).setId(null);

        // 调用
        Long itemRequisitionId = itemRequisitionService.createItemRequisition(createReqVO);
        // 断言
        assertNotNull(itemRequisitionId);
        // 校验记录的属性是否正确
        ItemRequisitionDO itemRequisition = itemRequisitionMapper.selectById(itemRequisitionId);
        assertPojoEquals(createReqVO, itemRequisition, "id");
    }

    @Test
    public void testUpdateItemRequisition_success() {
        // mock 数据
        ItemRequisitionDO dbItemRequisition = randomPojo(ItemRequisitionDO.class);
        itemRequisitionMapper.insert(dbItemRequisition);// @Sql: 先插入出一条存在的数据
        // 准备参数
        ItemRequisitionSaveReqVO updateReqVO = randomPojo(ItemRequisitionSaveReqVO.class, o -> {
            o.setId(dbItemRequisition.getId()); // 设置更新的 ID
        });

        // 调用
        itemRequisitionService.updateItemRequisition(updateReqVO);
        // 校验是否更新正确
        ItemRequisitionDO itemRequisition = itemRequisitionMapper.selectById(updateReqVO.getId()); // 获取最新的
        assertPojoEquals(updateReqVO, itemRequisition);
    }

    @Test
    public void testUpdateItemRequisition_notExists() {
        // 准备参数
        ItemRequisitionSaveReqVO updateReqVO = randomPojo(ItemRequisitionSaveReqVO.class);

        // 调用, 并断言异常
        assertServiceException(() -> itemRequisitionService.updateItemRequisition(updateReqVO), ITEM_REQUISITION_NOT_EXISTS);
    }

    @Test
    public void testDeleteItemRequisition_success() {
        // mock 数据
        ItemRequisitionDO dbItemRequisition = randomPojo(ItemRequisitionDO.class);
        itemRequisitionMapper.insert(dbItemRequisition);// @Sql: 先插入出一条存在的数据
        // 准备参数
        Long id = dbItemRequisition.getId();

        // 调用
        itemRequisitionService.deleteItemRequisition(id);
       // 校验数据不存在了
       assertNull(itemRequisitionMapper.selectById(id));
    }

    @Test
    public void testDeleteItemRequisition_notExists() {
        // 准备参数
        Long id = randomLongId();

        // 调用, 并断言异常
        assertServiceException(() -> itemRequisitionService.deleteItemRequisition(id), ITEM_REQUISITION_NOT_EXISTS);
    }

    @Test
    @Disabled  // TODO 请修改 null 为需要的值，然后删除 @Disabled 注解
    public void testGetItemRequisitionPage() {
       // mock 数据
       ItemRequisitionDO dbItemRequisition = randomPojo(ItemRequisitionDO.class, o -> { // 等会查询到
           o.setCode(null);
           o.setRequisitionDate(null);
           o.setDeliveryDate(null);
           o.setStatus(null);
           o.setProcessInstanceId(null);
           o.setPlanId(null);
           o.setRemark(null);
           o.setIsEnable(null);
           o.setCreateTime(null);
       });
       itemRequisitionMapper.insert(dbItemRequisition);
       // 测试 code 不匹配
       itemRequisitionMapper.insert(cloneIgnoreId(dbItemRequisition, o -> o.setCode(null)));
       // 测试 requisitionDate 不匹配
       itemRequisitionMapper.insert(cloneIgnoreId(dbItemRequisition, o -> o.setRequisitionDate(null)));
       // 测试 deliveryDate 不匹配
       itemRequisitionMapper.insert(cloneIgnoreId(dbItemRequisition, o -> o.setDeliveryDate(null)));
       // 测试 status 不匹配
       itemRequisitionMapper.insert(cloneIgnoreId(dbItemRequisition, o -> o.setStatus(null)));
       // 测试 processInstanceId 不匹配
       itemRequisitionMapper.insert(cloneIgnoreId(dbItemRequisition, o -> o.setProcessInstanceId(null)));
       // 测试 planId 不匹配
       itemRequisitionMapper.insert(cloneIgnoreId(dbItemRequisition, o -> o.setPlanId(null)));
       // 测试 remark 不匹配
       itemRequisitionMapper.insert(cloneIgnoreId(dbItemRequisition, o -> o.setRemark(null)));
       // 测试 isEnable 不匹配
       itemRequisitionMapper.insert(cloneIgnoreId(dbItemRequisition, o -> o.setIsEnable(null)));
       // 测试 createTime 不匹配
       itemRequisitionMapper.insert(cloneIgnoreId(dbItemRequisition, o -> o.setCreateTime(null)));
       // 准备参数
       ItemRequisitionPageReqVO reqVO = new ItemRequisitionPageReqVO();
       reqVO.setCode(null);

       reqVO.setStatus(null);
       reqVO.setProcessInstanceId(null);
       reqVO.setPlanId(null);
       reqVO.setRemark(null);
       reqVO.setIsEnable(null);
       reqVO.setCreateTime(buildBetweenTime(2023, 2, 1, 2023, 2, 28));

       // 调用
       PageResult<ItemRequisitionDO> pageResult = itemRequisitionService.getItemRequisitionPage(reqVO);
       // 断言
       assertEquals(1, pageResult.getTotal());
       assertEquals(1, pageResult.getList().size());
       assertPojoEquals(dbItemRequisition, pageResult.getList().get(0));
    }

}